const fs = require("fs");
const util = require("util");
const readdir = util.promisify(fs.readdir);
const Rss_parser = require("rss-parser");
var rss_parser = new Rss_parser();
var xml_parser = require("xml2js").parseString;

var to_run_sitemap;
var sitemap_stream;

function run(script, files, stream, callback){
    var childProcess = require("child_process");
    if (files.length === 0) return;

    var invoked = false,
        to_run = files.shift();
    var new_process = childProcess.fork(script, ["-f", to_run]);

    new_process.on("message", function (mes){
        mes = mes.toString();
        fs.readFile(to_run, (err, data) => {
            if (to_run.includes("rss")){
                rss_parser.parseString(data, (err, result) => {
                    stream.write(to_run +","+ result.items.length +","+ mes + "\n");
                });
            } else {
                xml_parser(data, (err, result) => {
                    stream.write(to_run +","+ result.urlset.url.length.toString() +","+ mes + "\n");
                });
            }
        });
        run(script, files, stream, callback);
    });

    new_process.on("error", function (err) {
        if (invoked) return;
        invoked = true;
        callback(err);
    });

    new_process.on("exit", function () {
        callback();
    });
}

function run_sitemap(){
    run("./unit_tests/test_sitemap.js", to_run_sitemap, sitemap_stream, function (){return;});
}

(async () => {
    fs.truncateSync("./results/rss.csv");
    fs.truncateSync("./results/sitemap.csv");

    var rss_stream = fs.createWriteStream("./results/rss.csv", {flags:"a"});
    sitemap_stream = fs.createWriteStream("./results/sitemap.csv", {flags:"a"});

    rss_stream.write("file name,items,items in index,title found,content complete\n");
    sitemap_stream.write("file name,items,items in index,title found,content complete\n");

    var rss_files = await readdir("./files/RSS");
    var to_run_rss = rss_files.map(file => "./files/RSS/" + file);
    var sitemap_files = await readdir("./files/SITEMAP");
    to_run_sitemap = sitemap_files.map(file => "./files/SITEMAP/" + file);

    run("./unit_tests/test_rss.js", to_run_rss, rss_stream, run_sitemap);
})();
