const puppeteer = require("puppeteer");
const Server = require("ws").Server;
const args = require("yargs")
    .usage("Usage : test_rss.js -file file_path")
    .demandOption(["file"])
    .alias("f", "file")
    .describe("file", "path to the RSS File")
    .nargs("file", 1)
    .argv;

var browser;

function init_server (){
    var ws = new Server({port: 9030});
    ws.on("connection", function(w){
        w.on("message", function(msg){
            ws.close();
            process.send(msg);
            browser.close();
        });
        w.on("close", function() {
            ws.close();
        });
    });
}

(async () => {
    init_server();
    browser = await puppeteer.launch();
    var page = await browser.newPage();
    await page.goto("https://softinst115787.host.vifib.net/public/unit_tests/test_rss.html");
    const [fileChooser] = await Promise.all([
        page.waitForFileChooser(),
        page.click("input#load")
    ]);
    await fileChooser.accept([args.file]);
})();
